'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _toConsumableArray2 = require('babel-runtime/helpers/toConsumableArray');

var _toConsumableArray3 = _interopRequireDefault(_toConsumableArray2);

exports.buildBindingStatement = buildBindingStatement;
exports.buildConstructor = buildConstructor;
exports.buildArrowFunction = buildArrowFunction;

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function buildBindingStatement(t, identifier) {
  return t.expressionStatement(t.assignmentExpression('=', t.memberExpression(t.thisExpression(), t.identifier(identifier)), t.callExpression(t.memberExpression(t.memberExpression(t.thisExpression(), t.identifier(identifier)), t.identifier('bind')), [t.thisExpression()])));
}

function buildConstructor(t) {
  return t.classMethod('constructor', t.identifier('constructor'), [], t.blockStatement([t.expressionStatement(t.callExpression(t.super(), []))]));
}

function buildArrowFunction(t, identifier, nodeArgs) {
  return t.arrowFunctionExpression([t.identifier('e')], t.blockStatement([t.expressionStatement(t.callExpression(t.memberExpression(t.thisExpression(), t.identifier(identifier)), [t.identifier('e')].concat((0, _toConsumableArray3.default)(nodeArgs))))]));
}